
#include <SPI.h>
#include <EEPROM.h> 
#include <LiquidCrystal_I2C.h>
#include <MsTimer2.h>

LiquidCrystal_I2C lcd(0x3F, 16, 2); 
 
float Freq = 9.4;
long  B, H_bit, L_bit, F_lcd, F_ust, Times;
const long F25 = 25000000;            // Частота кварца, если нет эталонного частотомера устанавливаем частоту 25000000 Гц
int   A[9], i = 1;
byte  W = 1, Form = 0, On = 0;
int   Sec[]         = {0};
byte Level          = 0;
#define Power_OFF     5
/*-----------------------------------------------------------------------------------------------------*/
const float R1      = 2200;                             // Резисторы делителя напряжения на
const float R2      = 10000;                            // Входное напряжение

const float Typ_Vbg = 1.095; // 1.0 -- 1.2              // Эту константу необходимо откалибровать индивидуально

float Akku[]        = {0};
/*-----------------------------------------------------------------------------------------------------*/
#define Gen_ON    On = 1; W = 1; i = 100;         lcd.setCursor(7, 1); lcd.print("ON ");
#define Gen_OFF   On = 0; W = 1; Freq = 0; i = 1; lcd.setCursor(7, 1); lcd.print("OFF");
/*=====================================================================================================*/
byte  PLUS, FORM, GEN_ON, MINUS, SWITCH, DIV, AUDIO;
const char *List[]  = {"NONE", "GEN_ON", "PLUS", "SWITCH", "MINUS", "FORM", "DIV", "AUDIO"};
int   Button        = 0;
int   keypad        = 0;

#define KEY_NONE      0
#define KEY_GEN_ON    1
#define KEY_PLUS      2
#define KEY_SWITCH    3
#define KEY_MINUS     4
#define KEY_FORM      5
#define KEY_DIV       6
#define KEY_AUDIO     7
/*-----------------------------------------------------------------------------------------------------*/
int getPressedButton()
{
  keypad = analogRead(0);                                // считываем значения с аналогового входа(A0) 
  
  if      (keypad < 100) return KEY_GEN_ON;
  else if (keypad < 250) return KEY_PLUS;  
  else if (keypad < 500) return KEY_SWITCH;  
  else if (keypad < 650) return KEY_MINUS;  
  else if (keypad < 870) return KEY_FORM; 
  
  return KEY_NONE;
}
/*=======================================================================================================
                                              Инициализация
=======================================================================================================*/
void setup() 
{
  Serial.begin(115200);
  Wire.begin();

  pinMode(KEY_DIV,   INPUT_PULLUP);
  pinMode(KEY_AUDIO, INPUT_PULLUP);
  
  pinMode(Power_OFF, OUTPUT);
  digitalWrite(Power_OFF, LOW);
  
  analogReference(DEFAULT);                             // DEFAULT INTERNAL использовать Vcc как AREF
  Read_Volt();
  
  lcd.init();
  lcd.backlight();
  lcd.setCursor(0, 0); lcd.print("<    AD9833    >");
  lcd.setCursor(0, 1); lcd.print("< ARDUINO NANO >");
  delay(2000); 
  lcd.clear();
  
  if(EEPROM.read(10) != 0) {for (byte e = 0; e <= 10; e++) {EEPROM.update(e, 0);}}
  for (byte e = 0; e <= 8; e++) A[e] = EEPROM.read(e); Form = EEPROM.read(9);
  AD_9833(); FORMA(); Gen_OFF
  MsTimer2::set(100, Timer_ISR); MsTimer2::start();
}
/*=======================================================================================================
                                              Главный цикл
=======================================================================================================*/
void loop() 
{
  KEYBOARD(); // DS1803();
  Read_Volt(); lcd.setCursor(0, 1); lcd.print(Akku[0]);
/*-----------------------------------------------------------------------------------------------------*/
  if (GEN_ON == 0)
  {
    switch (On)
    {
      case 0: Gen_ON  Sec[0] = 0; delay(300); break;
      case 1: Gen_OFF Sec[0] = 0; delay(300); break;
    }
  }
  if (FORM   == 0) {Form++; if (Form > 2) Form = 0; W = 1; Freq = 0; i = 1; Sec[0] = 0; delay(300);}
  if (SWITCH == 0) {i++; if (On == 1)  W = 1;   On = 1;   if (i > 7) i = 1; Sec[0] = 0; delay(300);}
  if (PLUS   == 0) {if (A[i] <= 9) A[i]++; if (A[i] >= 10) A[i] = 0;
                                                 W = 1; AD_9833(); FORMA(); Sec[0] = 0; delay(300);}
  if (MINUS  == 0) {if (A[i] >= 0) A[i]--; if (A[i] < 0) A[i] = 9;
                                                 W = 1; AD_9833(); FORMA(); Sec[0] = 0; delay(300);}
/*-----------------------------------------------------------------------------------------------------*/
  LCD();
 
  Freq = A[0] * pow(10, 7) + A[1] * pow(10, 6) + A[2] * pow(10, 5) + A[3] * pow(10, 4)+ A[4] * pow(10, 3) \
       + A[5] * pow(10, 2) + A[6] * 10 + A[7]  + float(A[8] * 0.1);
  
  if (On == 0) Freq = 0;
 
  if (W == 1)
  {
    AD_9833(); FORMA(); W = 0;
    for (byte e = 0; e <= 8; e++) EEPROM.update(e, A[e]); EEPROM.update(9, Form);
  }
  delay(10);  // <-- Не удалять, начинаются глюки на дисплее
}
/*=======================================================================================================
                                              
=======================================================================================================*/
void FORMA()
{
  lcd.setCursor(13, 1);
  switch (Form)
  {
    case 0: lcd.print("DAC"); Write_AD9833(0x2028); break;
    case 1: lcd.print("SIN"); Write_AD9833(0x2000); break;
    case 2: lcd.print("TRI"); Write_AD9833(0x2002); break;
  }
}
/*=======================================================================================================
                                              
=======================================================================================================*/
void Timer_ISR()
{
  Sec[0]++;
  if (Sec[0] >= 3000) digitalWrite(Power_OFF, HIGH);
}
/*=======================================================================================================
                                              
=======================================================================================================*/
void LCD()
{
  lcd.setCursor(0, 0); lcd.print("F  ");
/*-----------------------------------------------------------------------------------------------------/
  if (i == 0) 
  {
    if (millis() - Times <  500) lcd.print(A[0]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[0]);
/*-----------------------------------------------------------------------------------------------------*/
  if (i == 1) 
  {
    if (millis() - Times <  500) lcd.print(A[1]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[1]);
  lcd.print(".");
  if (i == 2) 
  {
    if (millis() - Times <  500) lcd.print(A[2]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[2]);
  if (i == 3) 
  {
    if (millis() - Times <  500) lcd.print(A[3]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[3]);
  if (i == 4) 
  {
    if (millis() - Times <  500) lcd.print(A[4]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[4]);
  lcd.print(".");
  if (i == 5) 
  {
    if (millis() - Times <  500) lcd.print(A[5]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[5]);
  if (i == 6) 
  {
    if (millis() - Times <  500) lcd.print(A[6]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[6]);
  if (i == 7) 
  {
    if (millis() - Times <  500) lcd.print(A[7]);
    if (millis() - Times >= 500) lcd.print(" ");
    if (millis() - Times > 1000) Times = millis();
  } 
  else lcd.print(A[7]);
  lcd.setCursor(14, 0); lcd.print("Hz");
}
/*=======================================================================================================
                                          Функция обработки нажатой кнопки
=======================================================================================================*/
void KEYBOARD()
{
  PLUS = 1; FORM = 1; GEN_ON = 1; MINUS = 1; SWITCH = 1;
  Button = getPressedButton();
  switch (Button)
  {
    case KEY_GEN_ON: GEN_ON = 0; break;
    case KEY_PLUS:   PLUS   = 0; break;
    case KEY_SWITCH: SWITCH = 0; break;
    case KEY_MINUS:  MINUS  = 0; break;
    case KEY_FORM:   FORM   = 0; break;
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (digitalRead(KEY_DIV)   == 0) Button = 6;
  if (digitalRead(KEY_AUDIO) == 0) Button = 7;
  if (Button != 0) 
  {
    Serial.print(" Button = "); Serial.print(Button);
    Serial.print(" : "); Serial.print(List[Button]);
    Serial.println(" ");
  }
/*-----------------------------------------------------------------------------------------------------*/
}
/*=======================================================================================================
                                              
=======================================================================================================*/
void Write_AD9833(uint16_t Data)
{
  SPI.beginTransaction(SPISettings(SPI_CLOCK_DIV2, MSBFIRST, SPI_MODE2));
  digitalWrite(SS, LOW);
  delayMicroseconds(1);
  SPI.transfer16(Data);
  digitalWrite(SS, HIGH);
  SPI.endTransaction();
}
/*=======================================================================================================
                                              
=======================================================================================================*/
void AD_9833()
{
  B = Freq * pow(2, 28) / F25;
  if (B < 16383) {L_bit = B + 0x4000 ; H_bit = 0x4000;}
  else {H_bit = (B >> 14) + 0x4000; L_bit = B - (H_bit << 14) + 0x4000;}
  SPI.begin();
  Write_AD9833(0x2100);      // 0010 0001 0000 0000 - Reset + DB28
  Write_AD9833(L_bit);       // 0100 0000 0000 0000 - Freq0 LSB 
  Write_AD9833(H_bit);       // 0100 0000 0000 0000 - Freq0 MSB 
  Write_AD9833(0xC000);      // 1100 0000 0000 0000 - Phase0 
  Write_AD9833(0x2000);      // 0010 0000 0000 0000 - Exit Reset
} 
/*=======================================================================================================
                                              Чтение напряжения аккумулятора
=======================================================================================================*/
void Read_Volt() 
{
  float Vcc = Read_Vcc();
  int Cur_Volt = 0.0;
  
  for (int i = 0; i < 5; i++) 
  {
    Cur_Volt = Cur_Volt + analogRead(1);
    delay(10);
  }
  
  Cur_Volt = Cur_Volt / 5;
  float V  = (Cur_Volt * Vcc) / 1024.0;
  Akku[0] = (V / (R2 / (R1 + R2)));
    
  analogWrite(1, 0);
}
/*=======================================================================================================
                                              
=======================================================================================================*/
float Read_Vcc() 
{
  float result = 0.0;
  float tmp = 0.0;

  for (byte i = 0; i < 5; i++) 
  {
    // Read 1.1V reference against AVcc
    // set the reference to Vcc and the measurement to the internal 1.1V reference
    
    #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
        ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
    #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
        ADMUX = _BV(MUX5) | _BV(MUX0);
    #elif defined (__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)
        ADMUX = _BV(MUX3) | _BV(MUX2);
    #else
        ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1); // works on an Arduino 168 or 328
    #endif

    delay(3);                                                   // Wait for Vref to settle
    ADCSRA |= _BV(ADSC);                                        // Start conversion
    while (bit_is_set(ADCSRA,ADSC));                            // measuring

    uint8_t low  = ADCL;                                        // must read ADCL first - it then locks ADCH
    uint8_t high = ADCH;                                        // unlocks both

    tmp = (high << 8) | low;
    tmp = (Typ_Vbg * 1023.0) / tmp;
    result = result + tmp;
    delay(5);
  }

  result = result / 5;
  return result;
}

char * TimeToString(unsigned long t)                            // t is time in seconds = millis()/1000;
{
  static char str[12];
  long h = t / 3600;
  t = t % 3600;
  int m = t / 60;
  int s = t % 60;
  sprintf(str, "%04ld:%02d:%02d", h, m, s);
  return str;
}
/*=====================================================================================================*/
